Imports System.Runtime.InteropServices

Public Class ADSmartIO
    Public Enum PortName
        A = 0
        B = 1
        C = 2
        D = 3
    End Enum

    '---------- SMARTIO DEFINITIONS ----------
    <DllImport("smartio.dll", EntryPoint:="SIOFirmwareVersion")> _
    Private Shared Function SIOFirmwareVersionS() As UInt32
    End Function

    <DllImport("smartio.dll", EntryPoint:="SIOReadDeviceVersion")> _
    Private Shared Function SIOReadDeviceVersionS() As UInt32
    End Function

    <DllImport("smartio.dll", EntryPoint:="SIOReadDevicePartType")> _
    Private Shared Function SIOReadDevicePartTypeS() As UInt32
    End Function

    <DllImport("smartio.dll", EntryPoint:="SIOReadKeypad")> _
    Private Shared Function SIOReadKeypadS() As Byte
    End Function

    <DllImport("smartio.dll", EntryPoint:="SIOSetKeyPadSize")> _
    Private Shared Function SIOSetKeyPadSizeS(ByVal Cols As Byte, ByVal Rows As Byte) As Boolean
    End Function

    <DllImport("smartio.dll", EntryPoint:="SIOSetSpeaker")> _
    Private Shared Function SIOSetSpeakerS(ByVal Duration As Byte, ByVal Tone As Byte) As Boolean
    End Function

    <DllImport("smartio.dll", EntryPoint:="SIOAnalogConversion")> _
    Private Shared Function SIOAnalogConversionS(ByVal Channel As Byte) As UInt32
    End Function

    <DllImport("smartio.dll", EntryPoint:="SIOReadVoltage")> _
    Private Shared Function SIOReadVoltageS() As UInt32
    End Function

    <DllImport("smartio.dll", EntryPoint:="SIOReadTemperature")> _
    Private Shared Function SIOReadTemperatureS() As UInt32
    End Function

    <DllImport("smartio.dll", EntryPoint:="SIOSelectOption")> _
    Private Shared Sub SIOSelectOptionS(ByVal NewOption As Byte)
    End Sub

    <DllImport("smartio.dll", EntryPoint:="SIOBackLightPwm")> _
    Private Shared Sub SIOBackLightPwmS(ByVal Value As Byte)
    End Sub

    <DllImport("smartio.dll", EntryPoint:="SIOBackLightVEEPwm")> _
    Private Shared Sub SIOBackLightVEEPwmS(ByVal Value As Byte)
    End Sub

    <DllImport("smartio.dll", EntryPoint:="SIOBackLightON")> _
    Private Shared Sub SIOBackLightONS()
    End Sub

    <DllImport("smartio.dll", EntryPoint:="SIOBackLightOFF")> _
    Private Shared Sub SIOBackLightOFFS()
    End Sub

    <DllImport("smartio.dll", EntryPoint:="SIOWritePortA")> _
    Private Shared Sub SIOWritePortAS(ByVal Value As Byte)
    End Sub

    <DllImport("smartio.dll", EntryPoint:="SIOWritePortB")> _
    Private Shared Sub SIOWritePortBS(ByVal Value As Byte)
    End Sub

    <DllImport("smartio.dll", EntryPoint:="SIOWritePortC")> _
    Private Shared Sub SIOWritePortCS(ByVal Value As Byte)
    End Sub

    <DllImport("smartio.dll", EntryPoint:="SIOWritePortD")> _
    Private Shared Sub SIOWritePortDS(ByVal Value As Byte)
    End Sub

    <DllImport("smartio.dll", EntryPoint:="SIOReadPortA")> _
    Private Shared Function SIOReadPortAS() As UInt32
    End Function

    <DllImport("smartio.dll", EntryPoint:="SIOReadPortB")> _
    Private Shared Function SIOReadPortBS() As UInt32
    End Function

    <DllImport("smartio.dll", EntryPoint:="SIOReadPortC")> _
    Private Shared Function SIOReadPortCS() As UInt32
    End Function

    <DllImport("smartio.dll", EntryPoint:="SIOReadPortD")> _
    Private Shared Function SIOReadPortDS() As UInt32
    End Function

    <DllImport("smartio.dll", EntryPoint:="SIOInitDDRA")> _
    Private Shared Sub SIOInitDDRAS(ByVal Value As Byte)
    End Sub

    <DllImport("smartio.dll", EntryPoint:="SIOInitDDRB")> _
    Private Shared Sub SIOInitDDRBS(ByVal Value As Byte)
    End Sub

    <DllImport("smartio.dll", EntryPoint:="SIOInitDDRC")> _
    Private Shared Sub SIOInitDDRCS(ByVal Value As Byte)
    End Sub

    <DllImport("smartio.dll", EntryPoint:="SIOInitDDRD")> _
    Private Shared Sub SIOInitDDRDS(ByVal Value As Byte)
    End Sub

    <DllImport("smartio.dll", EntryPoint:="SIOSetSSPTimeout")> _
    Private Shared Function SIOSetSSPTimeoutS(ByVal Timeout As UInt32) As Boolean
    End Function


    '---------- KEYBDDR DEFINITIONS ----------
    <DllImport("keybddr.dll", EntryPoint:="SIOFirmwareVersion")> _
    Private Shared Function SIOFirmwareVersionK() As UInt32
    End Function

    <DllImport("keybddr.dll", EntryPoint:="SIOReadDeviceVersion")> _
    Private Shared Function SIOReadDeviceVersionK() As UInt32
    End Function

    <DllImport("keybddr.dll", EntryPoint:="SIOReadDevicePartType")> _
    Private Shared Function SIOReadDevicePartTypeK() As UInt32
    End Function

    <DllImport("keybddr.dll", EntryPoint:="SIOReadKeypad")> _
    Private Shared Function SIOReadKeypadK() As Byte
    End Function

    <DllImport("keybddr.dll", EntryPoint:="SIOSetKeyPadSize")> _
    Private Shared Function SIOSetKeyPadSizeK(ByVal Cols As Byte, ByVal Rows As Byte) As Boolean
    End Function

    <DllImport("keybddr.dll", EntryPoint:="SIOSetSpeaker")> _
    Private Shared Function SIOSetSpeakerK(ByVal Duration As Byte, ByVal Tone As Byte) As Boolean
    End Function

    <DllImport("keybddr.dll", EntryPoint:="SIOAnalogConversion")> _
    Private Shared Function SIOAnalogConversionK(ByVal Channel As Byte) As UInt32
    End Function

    <DllImport("keybddr.dll", EntryPoint:="SIOReadVoltage")> _
    Private Shared Function SIOReadVoltageK() As UInt32
    End Function

    <DllImport("keybddr.dll", EntryPoint:="SIOReadTemperature")> _
    Private Shared Function SIOReadTemperatureK() As UInt32
    End Function

    <DllImport("keybddr.dll", EntryPoint:="SIOSelectOption")> _
    Private Shared Sub SIOSelectOptionK(ByVal NewOption As Byte)
    End Sub

    <DllImport("keybddr.dll", EntryPoint:="SIOBackLightPwm")> _
    Private Shared Sub SIOBackLightPwmK(ByVal Value As Byte)
    End Sub

    <DllImport("keybddr.dll", EntryPoint:="SIOBackLightVEEPwm")> _
    Private Shared Sub SIOBackLightVEEPwmK(ByVal Value As Byte)
    End Sub

    <DllImport("keybddr.dll", EntryPoint:="SIOBackLightON")> _
    Private Shared Sub SIOBackLightONK()
    End Sub

    <DllImport("keybddr.dll", EntryPoint:="SIOBackLightOFF")> _
    Private Shared Sub SIOBackLightOFFK()
    End Sub

    <DllImport("keybddr.dll", EntryPoint:="SIOWritePortA")> _
    Private Shared Sub SIOWritePortAK(ByVal Value As Byte)
    End Sub

    <DllImport("keybddr.dll", EntryPoint:="SIOWritePortB")> _
    Private Shared Sub SIOWritePortBK(ByVal Value As Byte)
    End Sub

    <DllImport("keybddr.dll", EntryPoint:="SIOWritePortC")> _
    Private Shared Sub SIOWritePortCK(ByVal Value As Byte)
    End Sub

    <DllImport("keybddr.dll", EntryPoint:="SIOWritePortD")> _
    Private Shared Sub SIOWritePortDK(ByVal Value As Byte)
    End Sub

    <DllImport("keybddr.dll", EntryPoint:="SIOReadPortA")> _
    Private Shared Function SIOReadPortAK() As UInt32
    End Function

    <DllImport("keybddr.dll", EntryPoint:="SIOReadPortB")> _
    Private Shared Function SIOReadPortBK() As UInt32
    End Function

    <DllImport("keybddr.dll", EntryPoint:="SIOReadPortC")> _
    Private Shared Function SIOReadPortCK() As UInt32
    End Function

    <DllImport("keybddr.dll", EntryPoint:="SIOReadPortD")> _
    Private Shared Function SIOReadPortDK() As UInt32
    End Function

    <DllImport("keybddr.dll", EntryPoint:="SIOInitDDRA")> _
    Private Shared Sub SIOInitDDRAK(ByVal Value As Byte)
    End Sub

    <DllImport("keybddr.dll", EntryPoint:="SIOInitDDRB")> _
    Private Shared Sub SIOInitDDRBK(ByVal Value As Byte)
    End Sub

    <DllImport("keybddr.dll", EntryPoint:="SIOInitDDRC")> _
    Private Shared Sub SIOInitDDRCK(ByVal Value As Byte)
    End Sub

    <DllImport("keybddr.dll", EntryPoint:="SIOInitDDRD")> _
    Private Shared Sub SIOInitDDRDK(ByVal Value As Byte)
    End Sub

    <DllImport("keybddr.dll", EntryPoint:="SIOSetSSPTimeout")> _
    Private Shared Function SIOSetSSPTimeoutK(ByVal Timeout As UInt32) As Boolean
    End Function


    ' functions try to call from smartio.dll first.  
    ' if that fails, they call keybddr.dll
    ' if that fails, they throw an exception

    Public Shared Function FirmwareVersion() As System.UInt32
        Try
            Return SIOFirmwareVersionS()
        Catch
            Try
                Return SIOFirmwareVersionK()

            Catch e As Exception
                Throw e
            End Try
        End Try
    End Function

    Public Shared Function DeviceVersion() As System.UInt32
        Try
            Return SIOReadDeviceVersionS()
        Catch
            Try
                Return SIOReadDeviceVersionK()

            Catch e As Exception
                Throw e
            End Try
        End Try
    End Function

    Public Shared Function DevicePartType() As System.UInt32
        Try
            Return SIOReadDevicePartTypeS()
        Catch
            Try
                Return SIOReadDevicePartTypeK()

            Catch e As Exception
                Throw e
            End Try
        End Try
    End Function

    Public Shared Function ReadKeypad() As Byte
        Try
            Return SIOReadKeypadS()
        Catch
            Try
                Return SIOReadKeypadK()

            Catch e As Exception
                Throw e
            End Try
        End Try
    End Function

    Public Shared Function SetKeyPadSize(ByVal Columns As Byte, ByVal Rows As Byte) As Boolean
        Try
            Return SIOSetKeyPadSizeS(Columns, Rows)
        Catch
            Try
                Return SIOSetKeyPadSizeK(Columns, Rows)

            Catch e As Exception
                Throw e
            End Try
        End Try
    End Function

    Public Shared Function SetSpeaker(ByVal Duration As Byte, ByVal Tone As Byte) As Boolean
        Try
            Return SIOSetSpeakerS(Duration, Tone)
        Catch
            Try
                Return SIOSetSpeakerK(Duration, Tone)

            Catch e As Exception
                Throw e
            End Try
        End Try
    End Function

    Public Shared Function AnalogConversion(ByVal Channel As Byte) As System.UInt32
        Try
            Return SIOAnalogConversionS(Channel)
        Catch
            Try
                Return SIOAnalogConversionK(Channel)

            Catch e As Exception
                Throw e
            End Try
        End Try
    End Function

    Public Shared Function ReadVoltage() As System.UInt32
        Try
            Return SIOReadVoltageS()
        Catch
            Try
                Return SIOReadVoltageK()

            Catch e As Exception
                Throw e
            End Try
        End Try
    End Function
    Public Shared Function ReadTemperature() As System.UInt32
        Try
            Return SIOReadTemperatureS()
        Catch
            Try
                Return SIOReadTemperatureK()

            Catch e As Exception
                Throw e
            End Try
        End Try
    End Function

    Public Shared Sub SelectOption(ByVal OptionValue As Byte)
        Try
            SIOSelectOptionS(OptionValue)
        Catch
            Try
                SIOSelectOptionK(OptionValue)

            Catch e As Exception
                Throw e
            End Try
        End Try
    End Sub

    Public Shared Sub BacklightPwm(ByVal NewValue As Byte)
        Try
            SIOBackLightPwmS(NewValue)
        Catch
            Try
                SIOBackLightPwmK(NewValue)

            Catch e As Exception
                Throw e
            End Try
        End Try
    End Sub
    Public Shared Sub VEEPwm(ByVal NewValue As Byte)
        Try
            SIOBackLightVEEPwmS(NewValue)
        Catch
            Try
                SIOBackLightVEEPwmK(NewValue)

            Catch e As Exception
                Throw e
            End Try
        End Try
    End Sub

    Public Shared Sub BacklightOn()
        Try
            SIOBackLightONS()
        Catch
            Try
                SIOBackLightONK()

            Catch e As Exception
                Throw e
            End Try
        End Try
    End Sub
    Public Shared Sub BacklightOff()
        Try
            SIOBackLightOFFS()
        Catch
            Try
                SIOBackLightOFFK()

            Catch e As Exception
                Throw e
            End Try
        End Try
    End Sub

    Public Shared Function SetSSPTimeout(ByVal Timeout As System.UInt32) As Boolean
        Try
            Return SIOSetSSPTimeoutS(Timeout)
        Catch
            Try
                Return SIOSetSSPTimeoutK(Timeout)

            Catch e As Exception
                Throw e
            End Try
        End Try
    End Function
    Public Shared Sub WritePort(ByVal Port As PortName, ByVal NewValue As Byte)
        Try
            Select Case Port
                Case PortName.A
                    SIOWritePortAS(NewValue)
                    Exit Sub
                Case PortName.B
                    SIOWritePortBS(NewValue)
                    Exit Sub
                Case PortName.C
                    SIOWritePortCS(NewValue)
                    Exit Sub
                Case PortName.D
                    SIOWritePortDS(NewValue)
                    Exit Sub
            End Select
        Catch
            Try
                Select Case Port
                    Case PortName.A
                        SIOWritePortAK(NewValue)
                        Exit Sub
                    Case PortName.B
                        SIOWritePortBK(NewValue)
                        Exit Sub
                    Case PortName.C
                        SIOWritePortCK(NewValue)
                        Exit Sub
                    Case PortName.D
                        SIOWritePortDK(NewValue)
                        Exit Sub
                End Select
            Catch e As Exception
                Throw e
            End Try
        End Try
    End Sub
    Public Shared Function ReadPort(ByVal Port As PortName) As System.UInt32
        Try
            Select Case Port
                Case PortName.A
                    Return SIOReadPortAS()
                Case PortName.B
                    Return SIOReadPortBS()
                Case PortName.C
                    Return SIOReadPortCS()
                Case PortName.D
                    Return SIOReadPortDS()
                Case Else
                    Return Convert.ToUInt32(&HFFFFFFFF)
            End Select
        Catch
            Try
                Select Case Port
                    Case PortName.A
                        Return SIOReadPortAK()
                    Case PortName.B
                        Return SIOReadPortBK()
                    Case PortName.C
                        Return SIOReadPortCK()
                    Case PortName.D
                        Return SIOReadPortDK()
                    Case Else
                        Return Convert.ToUInt32(&HFFFFFFFF)
                End Select
            Catch e As Exception
                Throw e
            End Try
        End Try
    End Function

    Public Shared Sub InitDDR(ByVal Port As PortName, ByVal DDRValue As Byte)
        Try
            Select Case Port
                Case PortName.A
                    SIOInitDDRAS(DDRValue)
                    Exit Sub
                Case PortName.B
                    SIOInitDDRBS(DDRValue)
                    Exit Sub
                Case PortName.C
                    SIOInitDDRCS(DDRValue)
                    Exit Sub
                Case PortName.D
                    SIOInitDDRDS(DDRValue)
                    Exit Sub
            End Select
        Catch
            Try
                Select Case Port
                    Case PortName.A
                        SIOInitDDRAK(DDRValue)
                        Exit Sub
                    Case PortName.B
                        SIOInitDDRBK(DDRValue)
                        Exit Sub
                    Case PortName.C
                        SIOInitDDRCK(DDRValue)
                        Exit Sub
                    Case PortName.D
                        SIOInitDDRDK(DDRValue)
                        Exit Sub
                End Select
            Catch e As Exception
                Throw e
            End Try
        End Try
    End Sub
End Class
